/* ***** BEGIN LICENSE BLOCK *****
 *
 *    Open-Xchange Calendar Provider
 *
 *    All intellectual property rights in the Software are protected by
 *    international copyright laws.
 *
 *    Any modifications to this package must retain all copyright notices
 *    of the original copyright holder(s) for the original code used.
 *
 *    After any such modifications, the original code will still remain
 *    copyrighted by the copyright holder(s) or original author(s).
 *
 *     Copyright (C) 2008 - 2009 Sebastian Kauss | fusionworkx
 *     mail:	                 sebastian.kauss@fusionworkx.com
 *
 *     This program is free software; you can redistribute it and/or modify it
 *     under the terms of the GNU General Public License as published by the Free
 *     Software Foundation; either version 2 of the License, or (at your option)
 *     any later version.
 *
 *     This program is distributed in the hope that it will be useful, but
 *     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 *     for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc., 59
 *     Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

var lastsyncDict = { };
var contactSync;

var contactListColumns = [ 1, 6 ];

var contactColumns = [
1, 6, 500, 501, 502, 506, 507, 508, 509, 510, 511, 515, 517, 518, 519, 520,
523, 525, 526, 527, 528, 542, 544, 548, 551, 555, 556, 557, 558, 569, 560,
594, 602
];

var contact_field_mapping = {
    1: 'object_id',
    6: 'last_modified',
    500: 'display_name',
    501: 'first_name',
    502: 'last_name',
    506: 'street_home',
    507: 'postal_code_home',
    508: 'city_home',
    509: 'state_home',
    510: 'country_home',
    511: 'birthday',
    515: 'nickname',
    517: 'anniversary',
    518: 'note',
    519: 'department',
    520: 'position',
    523: 'street_business',
    525: 'postal_code_business',
    526: 'city_business',
    527: 'state_business',
    528: 'country_business',
    542: 'telephone_business1',
    544: 'fax_business',
    548: 'telephone_home1',
    551: 'cellular_telephone1',
    555: 'email1',
    556: 'email2',
    557: 'email3',
    558: 'url',
    560: 'telephone_pager',
    569: 'company',
    594: 'number_of_distribution_list',
    602: 'mark_as_distributionlist'
};

var MAX_TIMESTAMP = 99999999999999;

var addressbookManagerObserver = {
    onItemAdded: function(parentDir, item) {
    //startProcessAsThread('add', [ parentDir, item ]);
    //genericOnItemAdded(parentDir, item);
    },

    onItemPropertyChanged: function(item, property, oldValue, newValue) {
    //startProcessAsThread('update', [ item, property, oldValue, newValue ]);
    //genericOnItemPropertyChanged(item, property, oldValue, newValue);
    },

    onItemRemoved: function(parentDir, item) {
        //startProcessAsThread('delete', [ parentDir, item ]);
        genericOnItemRemoved(parentDir, item);
    },

    QueryInterface: function(iid) {
        if (iid.equals(Components.interfaces.nsIAbListener)) {
            return this;
        }
        throw Components.results.NS_ERROR_NO_INTERFACE;
    }
};


function startProcessAsThread(action, params) {
    var addressbookWorkingThread = new AddressbookWorkingThread(action, params);
    var threadManager = Components.classes["@mozilla.org/thread-manager;1"].getService();
    var target = threadManager.mainThread;
    target.dispatch(addressbookWorkingThread, target.DISPATCH_NORMAL);
}

/* ADDRESSBOOK SYNC THREAD */
function AddressbookWorkingThread(action, params) {
    this.action = action;
    this.params = params;
}

AddressbookWorkingThread.prototype = {
    QueryInterface: function(iid) {
        if (iid.equals(Components.interfaces.nsIRunnable) ||
            iid.equals(Components.interfaces.nsISupports))
            return this;
        throw Components.results.NS_ERROR_NO_INTERFACE;
    },

    run: function() {
        if (this.action == 'add') {
            genericOnItemAdded(this.params[0], this.params[1]);
        } else if (this.action == 'update') {
            genericOnItemPropertyChanged(this.params[0], this.params[1], this.params[2], this.params[3]);
        } else if (this.action == 'delete') {
            genericOnItemRemoved(this.params[0], this.params[1]);
        } else if (this.action == 'local_add') {
            syncLocalNewContact2Server(this.params[0], this.params[1]);
        } else if (this.action == 'local_update') {
            syncLocalModifiedContact2Server(this.params[0], this.params[1]);
        } else {
            FW_WARN("unknown action '" + this.action + "' for thread process");
        }
    }
};

/*
 * GENERIC ADD, UPDATE AND REMOVE METHODS
 */
function genericOnItemAdded(parentDir, item) {
    FW_LOG("onItemAdded");

//
//    var statusManager = getStatusManagerInstance();
//
//    var addressbook = parentDir.QueryInterface(Components.interfaces.nsIAbDirectory);
//    if (!addressbook) {
//        return;
//    }
//
//    var card = item.QueryInterface(Components.interfaces.nsIAbCard);
//    if (!card) {
//        FW_LOG("item was no nsiAbCard, ignoring");
//        return;
//    }
//
//    var parentURI = getAddressbookURI(addressbook);
//
//    var displayName = getCardDisplayName(card);
//    var lastModified = getCardLastModified(card);
//
//    var addressbookHandler = getLocalAddressbookHandler(parentURI, false);
//    var localId = addressbookHandler.getLocalIdFromCard(card);
//    addressbookHandler.close();
//
//    if (localId) {
//        // if the localId exists the contact was created by the connector sync process
//        // so we can just ignore this event
//        FW_LOG("localId was found for new card, ignoring event");
//        return;
//    } else {
//        // localId already exists so it is a local added contact
//        FW_LOG("localId not found for new card, add to server");
//
//        var connection = getOXCalendarDBConnection();
//        var addressbookId = getAddressbookIdByURI(connection, parentURI);
//
//        var folder = getContactFolder4AddressbookURI(connection, parentURI);
//        if (folder == -1) {
//            FW_LOG("no ox folder mapping found for addressbook uri '" + parentURI + "', ignoring event");
//            return;
//        }
//
//        if (folder == 6) {
//            FW_LOG("cannot add contacts to the internal-user addressbook, ignoring event");
//            return;
//        }
//
//        // add own localId to new card
//        localId = getUUID();
//        addressbookHandler = getLocalAddressbookHandler(parentURI, false);
//        addressbookHandler.addUUID2Card(card, localId);
//        addressbookHandler.commit();
//        addressbookHandler.close();
//
//        var host = getOXCalendarPref(connection, "host");
//        var username = getOXCalendarPref(connection, "username");
//        var password = getOXCalendarPref(connection, "password");
//
//        var params = [ host, card, addressbookId, localId, 0, folder ];
//        var sessionHandler = new SessionHandler(host, username, password, connection);
//        var newestSession = getNewestSession(connection);
//        sessionHandler.setSession(newestSession[0], newestSession[1]);
//        sessionHandler.validateSession(addContactValidateSessionReady, params, false);
//    }
    
}

function genericOnItemPropertyChanged(item, property, oldValue, newValue) {
    FW_LOG("onItemPropertyChanged");


//    var statusManager = getStatusManagerInstance();
//
//    var card = item.QueryInterface(Components.interfaces.nsIAbCard);
//    if (!card) {
//        FW_LOG("item was no nsiAbCard, ignoring");
//        return;
//    }
//
//    var displayName = getCardDisplayName(card);
//    var lastModified = getCardLastModified(card);
//
//    FW_LOG("change contact '" + displayName + "' lastModified: " + lastModified);
//
//    // check if localId exists, if no localId exists it is maybe an add on server side
//    // if localId exists but no mapping exists add the contact too
//    // if the mapping exists update the contact
//
//    var hasCard = false;
//    var addressbookURI;
//
//    var connection = getOXCalendarDBConnection();
//
//    var addressbookURIs = [ ];
//    var prefAddressbookURI = getOXCalendarPref(connection, "addressbook-uri");
//    var prefInternaluserURI = getOXCalendarPref(connection, "internaluser-uri");
//
//    if (prefAddressbookURI) {
//        addressbookURIs.push(prefAddressbookURI);
//    }
//
//    if (prefInternaluserURI) {
//        addressbookURIs.push(prefInternaluserURI);
//    }
//
//    for (var a = 0; a < addressbookURIs.length; a++) {
//        addressbookURI = addressbookURIs[a];
//        hasCard = isCardInAddressbook(card, addressbookURI);
//
//        if (hasCard) {
//            break;
//        }
//    }
//
//    if (!hasCard) {
//        FW_LOG("card not found in addressbooks, ignoring update event");
//        return;
//    }
//
//    var addressbookHandler = getLocalAddressbookHandler(addressbookURI, false);
//    var localId = addressbookHandler.getLocalIdFromCard(card);
//    addressbookHandler.close();
//
//    if (localId) {
//        var wasRemoteUpdate = statusManager.getStatus("UPDATE_" + localId);
//        if (wasRemoteUpdate) {
//            FW_LOG("remote update detected, ignore request");
//            statusManager.deleteStatus("UPDATE_" + localId);
//            return;
//        }
//
//        var addressbookId = getAddressbookIdByURI(connection, addressbookURI);
//        var syncObject = getContactSyncObjectByLocalId(connection, addressbookId, localId);
//
//        if (!syncObject) {
//            FW_LOG("no contact mapping found for local id: " + localId + ", ignoring update event");
//            return;
//        }
//
//        var remoteId = syncObject['remote_id'];
//        var folder = getContactFolder4AddressbookURI(connection, addressbookURI);
//        if (folder == -1) {
//            FW_LOG("no ox folder mapping found for addressbook uri '" + addressbookURI + "', ignoring event");
//            return;
//        }
//
//        if (folder == 6) {
//            FW_LOG("cannot update contacts in the internal-user addressbook, ignoring event");
//            return;
//        }
//
//        var host = getOXCalendarPref(connection, "host");
//        var username = getOXCalendarPref(connection, "username");
//        var password = getOXCalendarPref(connection, "password");
//
//        var params = [ host, card, addressbookId, localId, remoteId, folder ];
//        var sessionHandler = new SessionHandler(host, username, password, connection);
//        var newestSession = getNewestSession(connection);
//        sessionHandler.setSession(newestSession[0], newestSession[1]);
//        sessionHandler.validateSession(editContactValidateSessionReady, params, false);
//    } else {
//        FW_LOG("contact has no localId, cannot find mapping to update on server");
//    }
    
}

function genericOnItemRemoved(parentDir, item) {
    FW_LOG("onItemRemoved");

    var statusManager = getStatusManagerInstance();

    var addressbook = parentDir.QueryInterface(Components.interfaces.nsIAbDirectory);
    if (!addressbook) {
        return;
    }

    var card = item.QueryInterface(Components.interfaces.nsIAbCard);
    if (!card) {
        FW_LOG("item was no nsiAbCard, ignoring");
        return;
    }

    var parentURI = getAddressbookURI(addressbook);

    var connection = getOXCalendarDBConnection();
    var addressbookId = getAddressbookIdByURI(connection, parentURI);

    var addressbookHandler;

    addressbookHandler = getLocalAddressbookHandler(parentURI, false);
    var localId = addressbookHandler.getLocalIdFromCard(card);
   
    addressbookHandler.close();

    if (localId) {
        var wasRemoteDelete = statusManager.getStatus("DELETE_" + localId);
        if (wasRemoteDelete) {
            FW_LOG("remote delete detected, ignore request");
            statusManager.deleteStatus("DELETE_" + localId);
            FW_LOG("removed status entry from status manager (DELETE_" + localId + ")");
            return;
        }

        // localId already exists so it is maybe a contact that exists on the server local added contact
        var syncObject = getContactSyncObjectByLocalId(connection, addressbookId, localId);

        if (!syncObject) {
            FW_LOG("no contact mapping found for local id: " + localId + ", ignoring delete event");
            return;
        }

        var remoteId = syncObject['remote_id'];
        var folder = syncObject['remote_folder'];

        if (folder == 6) {
            FW_LOG("don't delete contacts from the internal-user addressbook, ignoring event");
            return;
        }

        var host = getOXCalendarPref(connection, "host");
        var username = getOXCalendarPref(connection, "username");
        var password = getOXCalendarPref(connection, "password");

        var params = [ host, addressbookId, localId, remoteId, folder ];
        var sessionHandler = new SessionHandler(host, username, password, connection);
        var newestSession = getNewestSession(connection);
        sessionHandler.setSession(newestSession[0], newestSession[1]);
        sessionHandler.validateSession(deleteContactValidateSessionReady, params, false);
    } else {
        FW_LOG("contact has not local id. Maybe it was never synched and should not be deleted on server");
    }
}

/*
 * SAVE CONTACT CALLBACKS
 */

//
//function addContactValidateSessionReady(sessionHandler, params, success) {
//    saveContactValidateSessionReady(sessionHandler, params, success, false);
//}
//
//function editContactValidateSessionReady(sessionHandler, params, success) {
//    saveContactValidateSessionReady(sessionHandler, params, success, true);
//}
//
//function saveContactValidateSessionReady(sessionHandler, params, success, isUpdate) {
//    if (success) {
//        var host = params[0];
//        var card = params[1];
//        var addressbookId = params[2];
//        var localId = params[3];
//        var remoteId = params[4];
//        var folder = params[5];
//
//        var contactData = card2OXContact(card);
//
//        var callbackParams = [ card, addressbookId, localId, folder, sessionHandler ];
//        var contactRequestHelper = new ContactRequestHelper(host, sessionHandler.session, sessionHandler.cookie, sessionHandler.connection);
//        if (isUpdate) {
//            contactRequestHelper.updateContact(folder, remoteId, contactData, saveContactOnServerSuccess, saveContactOnServerFailed, callbackParams);
//        } else {
//            contactRequestHelper.addContact(folder, contactData, saveContactOnServerSuccess, saveContactOnServerFailed, callbackParams);
//        }
//    } else {
//        FW_WARN("cannot validate session, check credentials");
//    }
//}
//
//function saveContactOnServerSuccess(contactRequestHelper, remoteId, remoteTimestamp, params) {
//    FW_LOG("saveContactOnServerSuccess");
//
//    var card = params[0];
//    var addressbookId = params[1];
//    var localId = params[2];
//    var folder = params[3];
//    var sessionHandler = params[4];
//    var localTimestamp = getCardLastModified(card);
//
//    sessionHandler.logout(false);
//
//    var connection = sessionHandler.connection;
//    saveIdMapping(connection, addressbookId, localId, localTimestamp, folder, remoteId, remoteTimestamp);
//}
//
//function saveContactOnServerFailed(contactRequestHelper, params) {
//    FW_LOG("saveContactOnServerFailed");
//
//    var sessionHandler = params[6];
//    sessionHandler.logout(false);
//}


/*
 * DELETE CONTACT CALLBACKS
 */
function deleteContactValidateSessionReady(sessionHandler, params, success) {
    if (success) {
        var host = params[0];

        var addressbookId = params[1];
        var localId = params[2];
        var remoteId = params[3];
        var folder = params[4];

        FW_LOG("validate session found for deleting contact (remoteId=" + remoteId + ", folder=" + folder + ")");

        var callbackParams = [ addressbookId, localId, remoteId, folder, sessionHandler ];
        var contactRequestHelper = new ContactRequestHelper(host, sessionHandler.session, sessionHandler.cookie, sessionHandler.connection);
        contactRequestHelper.deleteContact(remoteId, folder, deleteContactOnServerSuccess, deleteContactOnServerFailed, callbackParams);
    } else {
        FW_WARN("cannot validate session, check credentials");
    }
}

function deleteContactOnServerSuccess(contactRequestHelper, params) {
    var addressbookId = params[0];
    var localId = params[1];
    var remoteId = params[2];
    var folder = params[3];

    FW_LOG("deleteContactOnServerSuccess remoteId=" + remoteId + ", folder=" + folder);

    var sessionHandler = params[4];
    //sessionHandler.logout(false);

    var connection = sessionHandler.connection;
    deleteContactIdMapping(connection, addressbookId, localId);
}

function deleteContactOnServerFailed(contactRequestHelper, error, params) {
    var remoteId = params[2];
    var folder = params[3];

    FW_LOG("deleteContactOnServerFailed remoteId=" + remoteId + ", folder=" + folder);

    var sessionHandler = params[4];
    sessionHandler.logout(false);
}

function initContactObserver() {
    FW_LOG("initContactObserver: ");

    var listenerFlag = Components.interfaces.nsIAbListener.directoryItemRemoved;
    var abManager = Components.classes["@mozilla.org/abmanager;1"].getService(Components.interfaces.nsIAbManager);
    abManager.addAddressBookListener(addressbookManagerObserver, listenerFlag);  
}

function startNewContactSync(syncManager) {
    FW_LOG("startNewContactSync");

    FW_LOG("get Status Manager Instance");
    var statusManager = getStatusManagerInstance();
    statusManager.setStatus("addrSync", true);

    var connection = getOXCalendarDBConnection();
  
    var host = getOXCalendarPref(connection, "host");
    var username = getOXCalendarPref(connection, "username");
    var password = getOXCalendarPref(connection, "password");
    FW_LOG("** startNewContactSync 1: startNewContactSync");
    
    var addressbookPref = FXJSON.fromString(getOXCalendarPref(connection, "addressbook-pref"));
    FW_LOG("** startNewContactSync 2: addressbookPref " +  addressbookPref);
    
    
    for (addressbookUri in addressbookPref) {
    	saveAddressbookURI(connection, addressbookUri);
    }
    var contactSync = new contactSyncHandler(host, username, password, addressbookPref, connection, syncManager);
    contactSync.start();


}

function contactSyncHandler(host, username, password, addressbookPref, connection, syncManager) {
    this.host = host;
    this.username = username;
    this.password = password;
    this.addressbookPref = addressbookPref;
    this.contactRequestCounter = 0;
    this.readContactsDict = { };
    this.connection = connection;
    this.syncManager = syncManager;
    this.syncLocalStorageReady = { };
}

contactSyncHandler.prototype = {

    start: function() {
        this.folderMapping = { };
        this.subscribedFolders = { };
        FW_LOG("** Sync AB: START");
        for(abUri in this.addressbookPref) {        	
        	var folderId = this.addressbookPref[abUri];
        	FW_LOG("** Sync AB: " + folderId + " / " + abUri);        	
        	this.subscribedFolders[ folderId ] = false;
        	this.readContactsDict[ folderId ] = { };
        	this.syncLocalStorageReady[abUri] = false;
        	this.folderMapping[folderId] = abUri;
        }
        
        this.sessionHandler = new SessionHandler(this.host, this.username, this.password, this.connection);
        var newestSession = getNewestSession(this.connection);
        this.sessionHandler.setSession(newestSession[0], newestSession[1]);
        this.sessionHandler.validateSession(readContactsValidateSession, [ this ], false);
    },

    readNextSubscribedFolder: function() {
        for (var folder in this.subscribedFolders) {
            if (this.subscribedFolders[folder]) {
                continue;
            } else {
                // read next contact folder and break loop
                FW_LOG("try to read contact list by folder id " + folder);
                this.readContactsList(folder);

                break;
            }
        }
    },

    /* READ SERVER CONTACTS */
    readContacts: function(folder) {
        FW_LOG("readContacts: ");
        var addressbookURI = this.folderMapping[folder];
        var addressbookId = getAddressbookIdByURI(this.connection, addressbookURI);
        var lastsync = getNewestContactLastModified(this.connection, addressbookId);

        FW_LOG("readContacts with lastsync=" + lastsync);

        var url = this.host + "/ajax/contacts?action=updates&session=" +
        this.sessionHandler.session + "&folder=" + folder +
        "&columns=" + encodeURIComponent(contactColumns.join()) +
        "&timestamp=" + lastsync + "&ignore=deleted";

        // call http request not as async for TB3 because it is already threaded
       
        readContactsHttpRequest(url, folder, this, true);
       
    },

    readContactsList: function(folder) {
        FW_LOG("readContactsList");
        var url = this.host + "/ajax/contacts?action=updates&session=" +
        this.sessionHandler.session + "&folder=" + folder +
        "&columns=" + encodeURIComponent(contactListColumns.join()) +
        "&timestamp=0&ignore=deleted";

        // call http request not as async for TB3 because it is already threaded
    
        readContactsListHttpRequest(url, folder, this, true);
       
    },

    readContactsReady: function(request, folder, async) {
        if(request.readyState == 4 && request.status == 200) {
            FW_LOG("readContactsReady detected for folder " + folder);

            var response = Function("return " + request.responseText)();
            var data = response['data'];
            var timestamp = response['timestamp'];

            lastsyncDict[folder] = timestamp;

            var contact_array = convert_arrays_to_objects(data, contactColumns, contact_field_mapping);
            FW_LOG("readContactsReady " + contact_array.length + " contacts fetched from server");

            this.subscribedFolders[folder] = true;
            this.readContactsDict[folder]['objects'] = contact_array;

            this.readAllContactsFromFolderReady( folder );
        }
    },

    readContactsListReady: function (request, folder) {
        if(request.readyState == 4 && request.status == 200) {
            FW_LOG("readContactsListReady detected for folder " + folder);

            var response = Function("return " + request.responseText)();
            var data = response['data'];

            var contact_array = convert_arrays_to_objects(data, contactColumns, contact_field_mapping);
            FW_LOG("readContactsListReady " + contact_array.length + " contact id's fetched from server");

            this.subscribedFolders[folder] = true;
            this.readContactsDict[folder]['id_list'] = contact_array;

            FW_LOG("try to read contacts by folder id " + folder);
            this.readContacts(folder);
        }
    },

    readAllContactsFromFolderReady: function( folder ) {
        FW_LOG("readAllContactsFromFolderReady folder=" + folder);
        var oxIdList = this.readContactsDict[folder]['id_list'];
        var oxContacts = this.readContactsDict[folder]['objects'];       
        
        var uri = this.folderMapping[folder];

        FW_LOG("prepare new sync process for uri: " + uri);

        var addressbookHandler = getLocalAddressbookHandler(uri, true);
        var addressbookId = getAddressbookIdByURI(this.connection, uri);

        FW_LOG("start new sync process for uri: " + uri);
        var contactSync = new ContactSync(this, this.connection, folder, addressbookHandler, addressbookId, uri, this.syncManager);
        contactSync.start(oxIdList, oxContacts);
    }
};

// ######## CALLBACK METHODS ##############
function readContactsValidateSession(sessionHandler, params, success) {
    if (success) {
        var contactSyncHandler = params[0];
        contactSyncHandler.sessionHandler = sessionHandler;
        contactSyncHandler.readNextSubscribedFolder();
    } else {
        FW_WARN("cannot create validate session, check credentials");
    }
}

// ######## HTTP REQUEST METHODS ##########
function readContactsHttpRequest(url, folder, contactSyncHandler, async) {
    FW_LOG("readContactsHttpRequest url=" + url + ", folder=" + folder + ", async=" + async);
    
    var request = getRequest();
    request.open("GET", url, async);
    request.setRequestHeader("cookie", contactSyncHandler.sessionHandler.cookie);
    request.overrideMimeType('text/javascript');

    if (async) {
        request.onreadystatechange = function() {
            contactSyncHandler.readContactsReady(request, folder);
        };
    }

    request.send(null);

    if (!async) {
        contactSyncHandler.readContactsReady(request, folder);
    }
}

function readContactsListHttpRequest(url, folder, contactSyncHandler, async) {
    FW_LOG("readContactsListHttpRequest url=" + url + ", folder=" + folder + ", async=" + async);

    var request = getRequest();
    request.open("GET", url, async);
    request.setRequestHeader("cookie", contactSyncHandler.sessionHandler.cookie);
    request.overrideMimeType('text/javascript');

    if (async) {
        request.onreadystatechange = function() {
            contactSyncHandler.readContactsListReady(request, folder);
        };
    }

    request.send(null);

    if (!async) {
        contactSyncHandler.readContactsListReady(request, folder);
    }
}

function contactSyncReady(syncManager, syncHandler, uri) {
    FW_LOG("sync process for uri " + uri + " finished - " + syncHandler.syncLocalStorageReady.toSource());

    var allLocalStoragesInSync = true;
    syncHandler.syncLocalStorageReady[uri] = true;
    for (var enumUri in syncHandler.syncLocalStorageReady) {
        var syncStatus = syncHandler.syncLocalStorageReady[enumUri];
        if (!syncStatus) {
            allLocalStoragesInSync = false;
        }
    }

    if (allLocalStoragesInSync) {
        addressbookSyncReady(syncManager);
    } else {
        syncHandler.readNextSubscribedFolder();
    }
}

function ContactSync(contactSyncHandler, connection, folder, addressbookHandler, addressbookId, uri, syncManager) {
    this.contactSyncHandler = contactSyncHandler;
    this.connection = connection;
    this.folder = folder;
    this.addressbookHandler = addressbookHandler;
    this.addressbookId = addressbookId;
    this.uri = uri;
    this.syncManager = syncManager;

    this.remoteUpdated = { };

    FW_LOG("ContactSync init: folder=" + this.folder + ", this.addressbookId=" + addressbookId + ", this.uri=" + uri);
}

ContactSync.prototype = {
    refreshSyncObjectCache: function() {
        this.syncObjectArray = getContactSyncObjects(this.connection, this.addressbookId);

        this.syncObjectsByLocalId = { };
        this.syncObjectsByRemoteId = { };

        for (var a = 0; a < this.syncObjectArray.length; a++) {
            var syncObject = this.syncObjectArray[a];
            var localId = syncObject['local_id'];
            var remoteId = syncObject['remote_id'];

            this.syncObjectsByLocalId[localId] = syncObject;
            this.syncObjectsByRemoteId[remoteId] = syncObject;
        }
    },

    start: function(oxIdList, oxContacts) {
        this.refreshSyncObjectCache();

        this.oxIdList = oxIdList;
        this.oxContacts = oxContacts;

        this.localNewContacts = [ ];
        this.localModifiedContacts = [ ];

        this.startRemoteSyncAsThread();
    },

    startRemoteSyncAsThread: function() {
        this.connection.beginTransaction();

        this.syncRemoteDeletedObjects();
        this.syncRemoteNewAndModifiedObjects();

        this.syncLocalAddressbook();
    },

    syncLocalAddessbookReady: function() {
        FW_LOG("syncLocalAddessbookReady");

        // commit all changes
        this.connection.commitTransaction();


        FW_LOG("commit the addressbook handler changes");
        // commit addressbookHandler
        this.addressbookHandler.commit();

        // close addressbookHandler
        this.addressbookHandler.close();

        contactSyncReady(this.syncManager, this.contactSyncHandler, this.uri);
    },

    syncRemoteNewAndModifiedObjects: function() {
        FW_LOG("try to add new and modified contacts from remote folder " + this.folder + " to local uri " + this.uri);
        var maxContacts = this.oxContacts.length;

        FW_LOG("read " + this.oxContacts.length + " contacts from server for sync");

        for (var a = 0; a < maxContacts; a++) {
            this.addRemoteObject2LocalStore(this.oxContacts[a]);
        }

        this.addressbookHandler.refreshCardCache();
        for (var localId in this.remoteUpdates) {
            var syncObject = this.remoteUpdates[localId];
            var remoteId = syncObject['remote_id'];
            var remoteTimestamp = syncObject['remote_timestamp'];
            var card = this.addressbookHandler.loadCard(localId);
            if (card) {
                var localTimestamp = getCardLastModified(card);
                updateContactMappingTimestamp(this.connection, this.addressbookId, localId, 'local_timestamp', localTimestamp);
                updateContactMappingTimestamp(this.connection, this.addressbookId, localId, 'remote_timestamp', remoteTimestamp);

                syncObject['local_timestamp'] = localTimestamp;

                this.syncObjectsByLocalId[localId] = syncObject;
                this.syncObjectsByRemoteId[remoteId] = syncObject;
            } else {
                FW_LOG("cannot load card for localId " + localId + ", delete mapping");
                deleteContactIdMapping(this.connection, this.addressbookId, [ localId ]);
            }
        }

        this.refreshSyncObjectCache();
    },

    syncRemoteDeletedObjects: function() {
        FW_LOG("try to remove deleted objects from folder " + this.folder + " in local storage uri " + this.uri);
        for (var localId in this.syncObjectsByLocalId) {
            var syncObject = this.syncObjectsByLocalId[localId];

            var remoteId = syncObject['remote_id'];
            var found = false;
            for (var b = 0; b < this.oxIdList.length; b++) {
                if (this.oxIdList[b]['object_id'] == remoteId) {
                    found = true;
                    break;
                }
            }

            if (!found) {
                // mapping for local object not found in remote id list
                var card = this.addressbookHandler.loadCard(localId);
                if (card) {
                    var statusManager = getStatusManagerInstance();
                    statusManager.setStatus("DELETE_" + localId, true);
                    deleteContactIdMapping(this.connection, this.addressbookId, [ localId ]);
                    this.addressbookHandler.deleteCard(localId);

                    // delete objects from cache
                    delete this.syncObjectsByLocalId[localId];
                    delete this.syncObjectsByRemoteId[remoteId];
                } else {
                    FW_LOG("deleted object from server was already locally deleted, try to delete mapping if existing");
                    deleteContactIdMapping(this.connection, this.addressbookId, [ localId ]);
                }
            }
        }
    },

    addRemoteObject2LocalStore: function(oxContact) {
        FW_LOG("addRemoteObject2LocalStore");

        if (oxContact['mark_as_distributionlist']) {
            FW_LOG("distribution list detected, just ignore object");
            return;
        }

        if (oxContact['last_name']) {
            FW_LOG("try to add object to local store: " + oxContact['last_name']);
        }

        var remoteId = oxContact['object_id'];
        var remoteTimestamp = oxContact['last_modified'];

        var localId;

        var card;
        var noMapping = false;

        var syncObject = this.syncObjectsByRemoteId[remoteId];
        if (syncObject) {
            FW_LOG("existing local sync object found by remote id " + remoteId);
            localId = syncObject['local_id'];

            FW_LOG("try to load local contact by id: " + localId);
            var oldRemoteTimestamp = syncObject['remote_timestamp'];

            card = this.addressbookHandler.loadCard(localId);
            if (card) {
                FW_LOG("object exists in local id mapping, check timestamps: oldts=" + oldRemoteTimestamp + ", newts=" + remoteTimestamp);
                if (oldRemoteTimestamp != remoteTimestamp) {
                    FW_LOG("changed remote object detected, try to update: " + oldRemoteTimestamp + ", " + remoteTimestamp);

                    var statusManager = getStatusManagerInstance();
                    statusManager.setStatus("UPDATE_" + localId, true);

                    this.addressbookHandler.updateCard(localId, oxContact);

                    var updatedCard = this.addressbookHandler.loadCard(localId);
                    if (updatedCard) {
                        var newLocalTimestamp = getCardLastModified(updatedCard);

                        updateContactMappingTimestamp(this.connection, this.addressbookId, localId, 'local_timestamp', newLocalTimestamp);
                        updateContactMappingTimestamp(this.connection, this.addressbookId, localId, 'remote_timestamp', remoteTimestamp);

                        syncObject['remote_timestamp'] = remoteTimestamp;
                        syncObject['local_timestamp'] = newLocalTimestamp;

                        // the timestamps of this sync objects in this
                        // dictionary are updated after this method
                        this.remoteUpdated[localId] = syncObject;
                    } else {
                        FW_LOG("cannot load updated card with localId: " + localId);
                    }
                } else {
                    FW_LOG("remote object wasn't changed, do nothing");
                }
            } else {
                FW_LOG("found local mapping but didn't found local object");
                deleteContactIdMapping(this.connection, this.addressbookId, [ localId ]);

                // delete objects from cache
                delete this.syncObjectsByLocalId[localId];
                delete this.syncObjectsByRemoteId[remoteId];

                noMapping = true;
            }
        } else {
            FW_LOG("no mapping for remote object with id " + remoteId + ", try to create new local object");
            noMapping = true;
        }

        if (noMapping) {
            localId = this.addressbookHandler.addCard(oxContact);
            FW_LOG("created new local object with id " + localId);
            card = this.addressbookHandler.loadCard(localId);
            if (!card) {
                FW_WARN("newly created object with id " + localId + " not found in local database, try to commit data");
                this.addressbookHandler.commit();
                card = this.addressbookHandler.loadCard(localId);
            }

            if (card) {
                var localTimestamp = getCardLastModified(card);
                insertContactIdMapping(this.connection, this.addressbookId, localId, localTimestamp, remoteId, this.folder, remoteTimestamp);
                var newSyncObject = {
                    'local_id': localId,
                    'local_timestamp': localTimestamp,
                    'remote_id': remoteId,
                    'remote_folder': this.folder,
                    'remote_timestamp': remoteTimestamp
                };

                this.syncObjectsByLocalId[localId] = newSyncObject;
                this.syncObjectsByRemoteId[remoteId] = newSyncObject;
            } else {
                FW_WARN("cannot load newly created object with local_id " + localId + ", ignore card in id mapping");
            }
        }
    },

    syncLocalAddressbook: function() {
        FW_LOG("syncLocalAddressbook: uri=" + this.uri );

        updateStatusBarWithThread(getI18nString('oxcalendar-provider.statusbar.reading-local-addressbooks'));

        var cards = this.addressbookHandler.listCards();

        FW_LOG("sync local new and modified objects");
        for (var a = 0; a < cards.length; a++) {
            var card = cards[a];

            // check if the card is really a card and ignore the entry if it is something else
            card = card.QueryInterface(Components.interfaces.nsIAbCard);
            if (!card) {
                FW_LOG("item was no nsiAbCard, ignoring");
                continue;
            }

            var localId = this.addressbookHandler.getLocalIdFromCard(card);
            if (this.remoteUpdated[localId]) {
                FW_LOG("local object " + localId + " was already updated in remote sync, override local changes");
                continue;
            }

            if (localId) {
                // modified object detected
                FW_LOG("localId '" + localId + "' found for card, try to update on server");
                this.syncLocalModifiedCard(card, localId);
            } else {
                FW_LOG("no localId found, try to add on server");
                localId = this.syncLocalNewCard(card);
            }
        }

        if (this.folder == 6) {
            FW_LOG("cannot add contacts to the internal-user addressbook, ignoring event");

            // just call the ready event for the local addressbook synchronisation
            this.syncLocalAddessbookReady();
        } else {
            syncLocalNewContacts2Server(this);
        }
    },

    syncLocalModifiedCard: function(card, localId) {
        FW_LOG("syncLocalModifiedCard: ");

        var localTimestamp = getCardLastModified(card);

        var syncObject = this.syncObjectsByLocalId[localId];
        if (syncObject) {
            // mapping between local and remote object exists, try to update contact on server
            var oldLocalTimestamp = syncObject['local_timestamp'];
            if (localTimestamp != oldLocalTimestamp) {
                FW_LOG("old local timestamp and new local timestamps are different: " + oldLocalTimestamp + ", " + localTimestamp);
                var remoteId = syncObject['remote_id'];
                var remoteTimestamp = syncObject['remote_timestamp'];
                var contactData = card2OXContact(card);
                var displayName = getCardDisplayName(card);
                FW_LOG("add local modified contact to event queue: name " + displayName + " folder " + this.folder + " uri " + this.uri);

                var localModifiedContact = {
                    'local_id': localId,
                    'local_timestamp': localTimestamp,
                    'remote_id': remoteId,
                    'remote_timstamp': remoteTimestamp,
                    'contact_data': contactData,
                    'card': card
                };

                this.localModifiedContacts.push( localModifiedContact );
            } else {
                FW_LOG("old local timestamp and new local timestamps are equals (" + oldLocalTimestamp + "), do nothing");
            }
        } else {
            // no mapping between local and remote object, create new remote object and add mapping
            this.syncLocalNewCard(card);
        }
    },

    syncLocalNewCard: function(card) {
        FW_LOG("syncLocalNewCard: ");

        var localTimestamp = getCardLastModified(card);
        var localId = getUUID();
        this.addressbookHandler.addUUID2Card(card, localId, true);

        var displayName = getCardDisplayName(card);

        var localNewContact = {
            'local_id': localId,
            'local_timestamp': localTimestamp,
            'card': card
        };

        this.localNewContacts.push( localNewContact );

        FW_LOG("add new local card to event queue: name " + displayName + " folder " + this.folder + " uri " + this.uri);
    }
};

function syncLocalNewContacts2Server(contactSync) {
    FW_LOG("syncLocalNewContacts2Server");
    syncLocalNewContact2Server(contactSync, 0);
}

function syncLocalNewContact2Server(contactSync, pos) {
    FW_LOG("syncLocalNewContact2Server: pos=" + pos+ ", contacts in queue: " + contactSync.localNewContacts.length);

    if (pos >= contactSync.localNewContacts.length) {
        // sync local new contacts done, call ready event
        syncLocalNewContacts2ServerReady(contactSync);
        return;
    }

    var displayCounter = ' ( ' + (pos+1) + ' - ' + contactSync.localNewContacts.length + ' )';
    updateStatusBarWithThread(getI18nString('oxcalendar-provider.statusbar.reading-local-new-contacts') + displayCounter);

    var sessionHandler = contactSync.contactSyncHandler.sessionHandler;

    var localNewContact = contactSync.localNewContacts[pos];

    // TODO: use contactData from contactSync['contact_data']
    var contactData = card2OXContact(localNewContact.card);
    var params = [ contactSync, pos, sessionHandler];

    var host = contactSync.contactSyncHandler.host;
    var connection = contactSync.contactSyncHandler.connection;

    var contactRequestHelper = new ContactRequestHelper(host, sessionHandler.session, sessionHandler.cookie, connection);
    contactRequestHelper.addContact(contactSync.folder, contactData, insertContactSuccess, insertContactFailed, params);
}

function syncLocalNewContacts2ServerReady(contactSync) {
    FW_LOG("syncLocalNewContacts2ServerReady");
    syncLocalModifiedContacts2Server(contactSync);
}

function syncLocalModifiedContacts2Server(contactSync) {
    syncLocalModifiedContact2Server(contactSync, 0);
}

function syncLocalModifiedContact2Server(contactSync, pos) {
    FW_LOG("syncLocalModifiedContact2Server: pos=" + pos+ ", contacts in queue: " + contactSync.localModifiedContacts.length);

    if (pos >= contactSync.localModifiedContacts.length) {
        // sync local new contacts done, call ready event
        syncLocalModifiedContacts2ServerReady(contactSync);
        return;
    }

    var displayCounter = ' ( ' + (pos+1) + ' - ' + contactSync.localModifiedContacts.length + ' )';
    updateStatusBarWithThread(getI18nString('oxcalendar-provider.statusbar.reading-local-modified-contacts') + displayCounter);

    var localModifiedContact = contactSync.localModifiedContacts[pos];
    var remoteId = localModifiedContact.remote_id;

    var contactData = card2OXContact(localModifiedContact.card);
    var params = [ contactSync, pos, sessionHandler];

    var host = contactSync.contactSyncHandler.host;
    var connection = contactSync.contactSyncHandler.connection;

    var sessionHandler = contactSync.contactSyncHandler.sessionHandler;

    var contactRequestHelper = new ContactRequestHelper(host, sessionHandler.session, sessionHandler.cookie, connection);
    contactRequestHelper.updateContact(contactSync.folder, remoteId, contactData, updateContactSuccess, updateContactFailed, params);
}

function syncLocalModifiedContacts2ServerReady(contactSync) {
    FW_LOG("syncLocalModifiedContacts2ServerReady");
    contactSync.syncLocalAddessbookReady();
}

function insertContactSuccess(contactRequestHelper, remoteId, remoteTimestamp, params) {
    FW_LOG("insertContactSuccess");

    var contactSync = params[0];
    var pos = params[1];
    var newPos = pos + 1;

    var localNewContacts = contactSync.localNewContacts;
    var localNewContact = localNewContacts[pos];

    var localId = localNewContact.local_id;
    var localTimestamp = localNewContact.local_timestamp;

    saveContactSuccess(contactRequestHelper, localId, localTimestamp, remoteId, remoteTimestamp, params);

    startProcessAsThread('local_add', [ contactSync, newPos ]);
    
}

function updateContactSuccess(contactRequestHelper, remoteId, remoteTimestamp, params) {
    FW_LOG("updateContactSuccess");

    var contactSync = params[0];
    var pos = params[1];
    var newPos = pos + 1;

    var localModifiedContacts = contactSync.localModifiedContacts;
    var localModifiedContact = localModifiedContacts[pos];

    var localId = localModifiedContact.local_id;
    var localTimestamp = localModifiedContact.local_timestamp;

    saveContactSuccess(contactRequestHelper, localId, localTimestamp, remoteId, remoteTimestamp, params);

   
    startProcessAsThread('local_update', [ contactSync, newPos ]);
   
}

function saveContactSuccess(contactRequestHelper, localId, localTimestamp, remoteId, remoteTimestamp, params) {
    FW_LOG("saveContactSuccess");

    var contactSync = params[0];  

    var addressbookId = contactSync.addressbookId;
    var folder = contactSync.folder;

    var connection = contactSync.contactSyncHandler.connection;
    saveIdMapping(connection, addressbookId, localId, localTimestamp, folder, remoteId, remoteTimestamp);
}

function insertContactFailed(contactRequestHelper, error, params) {
    FW_LOG("insertContactFailed, try to sync next contact");
    
    var contactSync = params[0];
    var pos = params[1];
    var newPos = pos + 1;

    startProcessAsThread('local_add', [ contactSync, newPos ]);
    
}

function updateContactFailed(contactRequestHelper, error, params) {
    FW_LOG("updateContactFailed, try to sync next contact");

    var contactSync = params[0];
    var pos = params[1];
    var newPos = pos + 1;

  
    startProcessAsThread('local_update', [ contactSync, newPos ]);
  
}

/* LOCAL ADDRESSBOOK SYNC THREAD */
function LocalSyncThread(contactSync) {
    this.contactSync = contactSync;
}

LocalSyncThread.prototype = {
    QueryInterface: function(iid) {
        if (iid.equals(Components.interfaces.nsIRunnable) ||
            iid.equals(Components.interfaces.nsISupports))
            return this;
        throw Components.results.NS_ERROR_NO_INTERFACE;
    },

    run: function() {
        this.contactSync.startRemoteSyncAsThread();
    }
};

function getStatusManagerInstance() {
    return Components.classes['@fusionworkx.com/common/statusmanager;1'].getService().wrappedJSObject;
}

function isCardInAddressbook(card, addressbookURI) {
    var addressbookHandler = getLocalAddressbookHandler(addressbookURI, true);
    var localId = addressbookHandler.getLocalIdFromCard(card);
    addressbookHandler.close();

    if (localId) {
        return true;
    }

    return false;
}


function getContactFolder4AddressbookURI(connection, addressbookURI) {

    for (folderId in this.folderMapping) {
    	var uri = this.folderMapping[folderId];
    	if(uri == addressbookURI) {
    		return folderId;
    	}
    }    

    return -1;
}

function saveIdMapping(connection, addressbookId, localId, localTimestamp, remoteFolder, remoteId, remoteTimestamp) {
    FW_LOG("saveIdMapping: localId=" + localId + ", localTimestamp=" + localTimestamp);
    var syncObject = getContactSyncObjectByLocalId(connection, addressbookId, localId);
    if (syncObject) {
        updateContactMappingTimestamp(connection, addressbookId, localId, 'local_timestamp', localTimestamp);
        updateContactMappingTimestamp(connection, addressbookId, localId, 'remote_timestamp', remoteTimestamp);
    } else {
        insertContactIdMapping(connection, addressbookId, localId, localTimestamp, remoteId, remoteFolder, remoteTimestamp);
    }
}

/*
 * Handy method to get the LocalAddressbookHandler for the given Thunderbird Versin
 */
function getLocalAddressbookHandler(uri, refreshCardCache) {
    return new LocalAddressbookHandlerTB3(uri, refreshCardCache);
    
}
