/* ***** BEGIN LICENSE BLOCK *****
 *
 *    Open-Xchange Calendar Provider
 *
 *    All intellectual property rights in the Software are protected by
 *    international copyright laws.
 *
 *    Any modifications to this package must retain all copyright notices
 *    of the original copyright holder(s) for the original code used.
 *
 *    After any such modifications, the original code will still remain
 *    copyrighted by the copyright holder(s) or original author(s).
 *
 *     Copyright (C) 2008 - 2009 Sebastian Kauss | fusionworkx
 *     mail:	                 sebastian.kauss@fusionworkx.com
 *
 *     This program is free software; you can redistribute it and/or modify it
 *     under the terms of the GNU General Public License as published by the Free
 *     Software Foundation; either version 2 of the License, or (at your option)
 *     any later version.
 *
 *     This program is distributed in the hope that it will be useful, but
 *     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 *     for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc., 59
 *     Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

const iFileLogger = Components.interfaces.IFileLogger;
const nsISupports = Components.interfaces.nsISupports;

function FileLogger() {
	// If you only need to access your component from Javascript, uncomment the following line:
	this.wrappedJSObject = this;
}

// class definition
FileLogger.prototype = {

	registerFileLogger: function() {
		var consoleListener = {
			loggingEnabled: true,

			observe:function( aMessage ) {
				if (this.loggingEnabled) {
					saveData2File(aMessage.message, true);
				}
			}
		};

        /*
		var loggingEnabled;
	
			loggingEnabled = cal.getPrefSafe("calendar.debug.log", false);
		

		consoleListener.loggingEnabled = loggingEnabled;
        */

		saveData2File("init log service", false);
		saveData2File("Addon version " + version, true);

		var consoleService = getConsoleService();
		consoleService.registerListener(consoleListener);
	},

	unregisterFileLogger: function() {

	},

	QueryInterface: function(aIID) {
		if (!aIID.equals(iFileLogger) && !aIID.equals(nsISupports)) {
			throw Components.results.NS_ERROR_NO_INTERFACE;
		}
		return this;
	}
};

function saveData2File(data, append) {
//	var prof = Components.classes["@mozilla.org/file/directory_service;1"].
//									getService(Components.interfaces.nsIProperties).
//									get("ProfD", Components.interfaces.nsIFile);
//
//	var extdir = "/extensions/\{E6050BDA-F130-11DD-8931-239656D89593\}";
//	var path = prof.path + extdir;
//
//	var filename = "/oxcalendar.log";
//
//	var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
//
//	if (path.match(/\\/g)) {
//		extdir = "\\extensions\\\{E6050BDA-F130-11DD-8931-239656D89593\}";
//		path = prof.path + extdir;
//
//		filename = "\\oxcalendar.log";
//	}
//
//	file.initWithPath(path + filename);
	
	//NOTE: disabled the code above since it does not work for all extentsion-installation methods:
	//		if you install an extension by using a referer-file, there is no actual folder for this
	//		extension in the extensions-folder ("ProfD")
	let file = __LOCATION__.parent.parent.clone();//getExtensionLocation();
    file.append("oxcalendar.log");
    
//    dump("\n using file for logging: "+file.path+"\n");//debug
    
	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].
							createInstance(Components.interfaces.nsIFileOutputStream);

	if (append) {
		foStream.init(file, 0x02 | 0x08 | 0x10, 0666, 0);
	} else {
		foStream.init(file, 0x02 | 0x08 | 0x20, 0666, 0);
	}

	var converter = Components.classes["@mozilla.org/intl/converter-output-stream;1"].
	createInstance(Components.interfaces.nsIConverterOutputStream);
	converter.init(foStream, "UTF-8", 0, 0);
	converter.writeString(data + "\n");
	converter.close();
}

