/* ***** BEGIN LICENSE BLOCK *****
 *
 *    Open-Xchange Calendar Provider
 *
 *    All intellectual property rights in the Software are protected by
 *    international copyright laws.
 *
 *    Any modifications to this package must retain all copyright notices 
 *    of the original copyright holder(s) for the original code used.
 *    
 *    After any such modifications, the original code will still remain
 *    copyrighted by the copyright holder(s) or original author(s).
 *
 *     Copyright (C) 2008 - 2009 Sebastian Kauss | fusionworkx
 *     mail:	                 sebastian.kauss@fusionworkx.com
 *
 *     This program is free software; you can redistribute it and/or modify it
 *     under the terms of the GNU General Public License as published by the Free
 *     Software Foundation; either version 2 of the License, or (at your option)
 *     any later version.
 * 
 *     This program is distributed in the hope that it will be useful, but
 *     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 *     for more details.
 * 
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc., 59
 *     Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 */

var appointmentColumns = [ 1, 2, 100, 101, 200, 201, 202, 203, 204, 206, 209, 210, 211, 212, 213, 214, 215, 216, 400, 401, 402, 220, 221, 222 ];

var lastSync = 0;

function ox6LoginHttpRequest(host, username, password, ox6Handler, callback, params, async) {
    FW_LOG("ox6LoginHttpRequest");
    var request = getRequest();

    var usernameEncoded = encodeURIComponent(username);
    var passwordEncoded = encodeURIComponent(password);

    var url = host + "/ajax/login";

    var httpParams = "action=login&name="+usernameEncoded+"&password="+passwordEncoded;

    request.open("POST", url, async);
    request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    request.setRequestHeader("Content-length", httpParams.length);
    request.setRequestHeader("Connection", "close");
    request.overrideMimeType('text/javascript');

    if (async) {
        request.onreadystatechange = function() {
            loginHttpReady(request, ox6Handler, callback, params);
        };
    }

    request.send(httpParams);

    if (!async) {
        loginHttpReady(request, ox6Handler, callback, params);
    }
}

function ox6ReadAppointmentsHttpRequest(url, session, cookie, syncManager, folder, callback, async) {
    var request = getRequest();
    request.open("GET", url, async);
    //request.setRequestHeader("cookie", cookie);
    request.overrideMimeType('text/javascript');

    if (async) {
        request.onreadystatechange = function() {
            readAppointmentsHttpReady(request, syncManager, folder, callback);
        };
    }

    request.send(null);

    if (!async) {
        readAppointmentsHttpReady(request, syncManager, folder, callback);
    }
}

function ox6ConfigHttpRequest(host, session, cookie, ox6Handler, callback, params, async) {
    var url = host + "/ajax/config/identifier?session=" + session;

    FW_LOG("oxConfigHttpRequest to url: " + url + " is async: " + async);

    var request = getRequest();
    request.open("GET", url, async);
    //request.setRequestHeader("cookie", cookie);
    request.overrideMimeType('text/javascript');

    if (async) {
        request.onreadystatechange = function() {
            configHttpReady(request, ox6Handler, host, callback, params, async);
        };
    }

    request.send(null);

    if (!async) {
        configHttpReady(request, ox6Handler, host, callback, params);
    }
}

function ox6LogoutHttpRequest(host, session, cookie, id, httpCallback) {
    FW_LOG("ox6LogoutHttpRequest");
    var url = host + "/ajax/login?session=" + session + "&action=logout";

    FW_LOG("logout url: " + url);
    var request = getRequest();
    request.open("GET", url, true);
    //request.setRequestHeader("cookie", cookie);
    request.overrideMimeType('text/javascript');
    request.onreadystatechange = function() {
        ox6LogoutHttpRequestReady(request, session, cookie, id);
    };
    request.send(null);
}

function ox6LogoutHttpRequestReady(request, session, cookie, id) {
    if (request.readyState == 4) {
        if (request.status == 200) {
            var jsonResponse = Function("return " + request.responseText)();
            if (!jsonResponse) {
                FW_LOG("session was successfully logged out");
                var connection = getOXCalendarDBConnection();
                deleteSession(connection, id);
            } else {
                if (jsonResponse.error) {
                    FW_WARN("session was not logged out");
                }
            }
        }
    }
}